Agora Java API Reference for Android

Public Attributes | List of all members
io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats Class Reference

Audio statistics of the remote user. More...

## Public Attributes
int | uid
int | quality
int | networkTransportDelay
int | jitterBufferDelay
int | audioLossRate
int | numChannels
int | receivedSampleRate
int | receivedBitrate
int | totalFrozenTime
int | frozenRate
int | mosValue
int | frozenRateByCustomPlcCount
int | plcCount
int | frozenCntByCustom
int | frozenTimeByCustom
long | totalActiveTime
long | publishDuration
int | qoeQuality
int | qualityChangedReason
int | rxAudioBytes
int | e2eDelay

## Detailed Description

Audio statistics of the remote user.

## Member Data Documentation

## ◆ uid

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.uid

The user ID of the remote user.

## ◆ quality

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.quality

The quality of the audio stream sent by the user.

- QUALITY_UNKNOWN (0): The quality is unknown.
- QUALITY_EXCELLENT (1): The quality is excellent.
- QUALITY_GOOD (2): The network quality seems excellent, but the bitrate can be slightly lower than excellent.
- QUALITY_POOR (3): Users can feel the communication is slightly impaired.
- QUALITY_BAD (4): Users cannot communicate smoothly.
- QUALITY_VBAD (5): The quality is so bad that users can barely communicate.
- QUALITY_DOWN (6): The network is down, and users cannot communicate at all.
- QUALITY_DETECTING (8): The last-mile probe test is in progress.

## ◆ networkTransportDelay

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.networkTransportDelay

The network delay (ms) from the sender to the receiver.

## ◆ jitterBufferDelay

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.jitterBufferDelay

The network delay (ms) from the audio receiver to the jitter buffer.

Note
  When the receiving end is an audience member and `audienceLatencyLevel` of `ClientRoleOptions` is 1, this parameter does not take effect.

## ◆ audioLossRate

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.audioLossRate

The frame loss rate (%) of the remote audio stream in the reported interval.

## ◆ numChannels

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.numChannels

The number of audio channels.

## ◆ receivedSampleRate

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.receivedSampleRate

The sampling rate of the received audio stream in the reported interval.

## ◆ receivedBitrate

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.receivedBitrate

The average bitrate (Kbps) of the received audio stream in the reported interval.

## ◆ totalFrozenTime

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.totalFrozenTime

The total freeze time (ms) of the remote audio stream after the remote user joins the channel. In a session, audio freeze occurs when the audio frame loss rate reaches 4%.

## ◆ frozenRate

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.frozenRate

The total audio freeze time as a percentage (%) of the total time when the audio is available. The audio is considered available when the remote user neither stops sending the audio stream nor disables the audio module after joining the channel.

## ◆ mosValue

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.mosValue

The quality of the remote audio stream in the reported interval. The quality is determined by the Agora real-time audio MOS (Mean Opinion Score) measurement method. The return value range is [0, 500]. Dividing the return value by 100 gets the MOS score, which ranges from 0 to 5. The higher the score, the better the audio quality. The subjective perception of audio quality corresponding to the Agora real-time audio MOS scores is as follows: | MOS score |

## Perception of audio quality | | -----------— |

| | Greater than 4 | Excellent. The audio sounds clear and smooth. | | From 3.5 to 4 | Good. The audio has some perceptible impairment but still sounds clear. | | From 3 to 3.5 | Fair. The audio freezes occasionally and requires attentive listening. | | From 2.5 to 3 | Poor. The audio sounds choppy and requires considerable effort to understand. | | From 2 to 2.5 | Bad. The audio has occasional noise. Consecutive audio dropouts occur, resulting in some information loss. The users can communicate only with difficulty. | | Less than 2 | Very bad. The audio has persistent noise. Consecutive audio dropouts are frequent, resulting in severe information loss. Communication is nearly impossible. |

## ◆ frozenRateByCustomPlcCount

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.frozenRateByCustomPlcCount

If the packet loss concealment (PLC) occurs for N consecutive times, freeze is considered as PLC occurring for M consecutive times. freeze cnt = (n_plc - n) / m

## ◆ plcCount

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.plcCount

The number of audio packet loss concealment

## ◆ frozenCntByCustom

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.frozenCntByCustom

@technical preview The number of times the remote audio stream has experienced freezing.

## ◆ frozenTimeByCustom

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.frozenTimeByCustom

@technical preview The total duration (ms) that the remote audio stream has been in a frozen state.

## ◆ totalActiveTime

long io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.totalActiveTime

The total active time (ms) between the start of the audio call and the callback of the remote user. The active time refers to the total duration of the remote user without the mute state.

## ◆ publishDuration

long io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.publishDuration

The total duration (ms) of the remote audio stream.

## ◆ qoeQuality

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.qoeQuality

The Quality of Experience (QoE) of the local user when receiving a remote audio stream.

- EXPERIENCE_QUALITY_GOOD (0): The QoE of the local user is good.
- EXPERIENCE_QUALITY_BAD (1): The QoE of the local user is poor.

## ◆ qualityChangedReason

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.qualityChangedReason

Reasons why the QoE of the local user when receiving a remote audio stream is poor.

- EXPERIENCE_REASON_NONE (0): No reason, indicating a good QoE of the local user.
- REMOTE_NETWORK_QUALITY_POOR (1): The remote user's network quality is poor.
- LOCAL_NETWORK_QUALITY_POOR (2): The local user's network quality is poor.
- WIRELESS_SIGNAL_POOR (4): The local user's Wi-Fi or mobile network signal is weak.
- WIFI_BLUETOOTH_COEXIST (8): The local user enables both Wi-Fi and bluetooth, and their signals interfere with each other. As a result, audio transmission quality is undermined.

## ◆ rxAudioBytes

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.rxAudioBytes

Total number of audio bytes received (bytes) before network countermeasures, represented by an aggregate value.

## ◆ e2eDelay

int io.agora.rtc2.IRtcEngineEventHandler.RemoteAudioStats.e2eDelay

End-to-end audio delay (in milliseconds), which refers to the time from when the audio is captured by the remote user to when it is played by the local user.